/*{*************************************************************************
              XMBBond.h  -  description
                 -------------------
     begin                : Fri Jul 21 2006
     copyright            : (C) 2006 by ImazInatIon
     email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *************************************************************************}*/

#ifndef XMBBOND_H
#define XMBBOND_H

//#include "XMBAtom.h"
//#include "XMBBondLine.h"
//#include "XMBStereoBond.h"
#include <qstring.h>

class XMBAtom;
class XMBMolecule;
class XMBBondLine;
class XMBStereoBond;
class XMoleculeBuilderDoc;

/**
 *@author Revanth
 */

enum XMBBondType{
	XMBBT_DashedLine,
	XMBBT_SingleBond,
	XMBBT_StereoUp,
	XMBBT_StereoDown,
	XMBBT_SingleDouble,
	XMBBT_Double,
	XMBBT_DoubleTriple,
	XMBBT_Triple
};

class XMBBond {
	public:

		// constructor given end atoms
		XMBBond( XMBAtom* from, XMBAtom *to, XMoleculeBuilderDoc* pDoc);

		// destructor
		~XMBBond();

		// set bond
		void setBond(void);

		// set bondlength
		void setLength(QString length);

		QString getLength(void);

		// change from Atom
		void setFromAtom( XMBAtom* );

		// change to Atom
		void setToAtom( XMBAtom* );

		// get form atom
		XMBAtom *getFromAtom();

		// get to Atom
		XMBAtom *getToAtom();

		//get molecule
		XMBMolecule *getMolecule();
		
		// add bond
		void addBond( XMBBondType bondtype, float angle=60);

		// delete bond
		bool deleteBond( XMBStereoBond *bond );
		bool deleteBond( XMBBondLine *bond );

		// move the bond
		void moveBy(double dx, double dy);

		// change colour
		void setColor( int r, int g, int b);

		//private:
		// doc
		XMoleculeBuilderDoc *doc;

		// type of bond
		XMBBondType type;

		// to and from atom
		XMBAtom *toAtom;
		XMBAtom *fromAtom;

		// bond length
		float bondlength;

		// max 3 bonds
		int bondCount; // bondType tells me about bondCount aneway keep it

		// bond1 creaated first, bond3 deleted first
		XMBBondLine *bond1;
		XMBBondLine *bond2;
		XMBBondLine *bond3;
		XMBStereoBond *stereoBond;

		// bond types
		XMBBondType bond1Type;
		XMBBondType bond2Type;
		XMBBondType bond3Type;
};

#endif

