/*{**************************************************************************
  XMBI3D.cpp  -  description
  -------------------
begin                : Fri Jul 21 2006
copyright            : (C) 2006 by ImazInatIon
email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *************************************************************************}*/


#include "XMBI3dView.h"
#include <math.h>
#include <iostream>

using namespace std;

#define CUTOFF	90.0
#define	KEYLAG	300

//int fps_font=(int)GLUT_BITMAP_8_BY_13;


XMBI3dView::XMBI3dView(QCanvas *c)
{
	pastTime=0;	spclkeys=0;
	rotation[0]=rotation[1]=rotation[2]=0;
	bondsCount=atomsCount=totalAtomCount=0;
	eye[0]=150;
	eye[1]=eye[2]=pos[0]=pos[1]=pos[2]=defaulteye=0;
	rho=20;
	rotYAngle=rotXAngle=0;
	ambience[0]=ambience[1]=ambience[2]=ambience[3]=0.1;
	diffuse[0]=diffuse[1]=diffuse[2]=diffuse[3]=1;
	specular[0]=specular[1]=specular[2]=specular[3]=1;
	position[0]=position[1]=position[3]=0;
	position[2]=1;
	canvas=c;

	nFlags = SDL_OPENGL | SDL_GL_DOUBLEBUFFER | SDL_HWPALETTE;// | SDL_FULLSCREEN;
}

XMBI3dView::~XMBI3dView()
{
}

/*
void renderBitmapString(float x, float y, void *font,char *string)
{
	char *c;
	glRasterPos2f(x, y);
	for (c=string; *c != '\0'; c++)
		glutBitmapCharacter(font, *c);
}

void setOrthographicProjection(int x,int y)
{
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, y, 0, x);
	glScalef(1, -1, 1);
	glTranslatef(0, -x, 0.0);
	glMatrixMode(GL_MODELVIEW);
}

void resetPerspectiveProjection()
{
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}
*/
int XMBI3dView::getIndex( XMBAtom *atom)
{
	for(int i=0; i< atomsCount; i++){
		if( atomsArr[i] == atom )
			return i;
	}
	return 0;
}

void XMBI3dView::RenderMolecule( XMBMolecule *molecule)
{
	atomsCount=bondsCount=0;
	QCanvasItemList l = canvas->allItems();
	XMBBond *bond;
	XMBBondLine *bondline;
	
	
	for(QCanvasItemList::iterator it=l.begin(); it != l.end(); it++)
		if( (*it)->rtti() == 6 && ((XMBAtom*)(*it))->getMolecule() == molecule )
		{
			atomsCount++;
			bondsCount += ((XMBAtom*)(*it))->getBondCount();
		}
	bondsCount /= 2;

	// get list of atoms and moelcules
        atomsArr = new XMBAtom*[atomsCount];
	XMBBond*** bondsArr = new XMBBond**[atomsCount];
	for(int i=0; i< atomsCount; i++)
	{
		bondsArr[i] = new XMBBond*[atomsCount];
		for(int j=0; j<atomsCount; j++)
			bondsArr[i][j] = NULL;
	}
	
	int t=0;
	for(QCanvasItemList::iterator it=l.begin(); it != l.end(); it++)
		if( (*it)->rtti() == 6 && ((XMBAtom*)(*it))->getMolecule() == molecule )
		{
			atomsArr[t++] = ((XMBAtom*)(*it));
			glPushMatrix();
				defaulteye=(((XMBAtom*)(*it))->getAtomZ()>defaulteye?((XMBAtom*)(*it))->getAtomZ():defaulteye);
				pos[0]+=((XMBAtom*)(*it))->getAtomZ();
				pos[1]+=((XMBAtom*)(*it))->x()-1000;
				pos[2]+=1000-((XMBAtom*)(*it))->y();
				totalAtomCount++;
				glTranslatef( ((XMBAtom*)(*it))->getAtomZ(), ((XMBAtom*)(*it))->x()-1000, 1000-((XMBAtom*)(*it))->y() );
				glColor3f( atoi(((XMBAtom*)(*it))->_atomColor[0])/255.0, atoi(((XMBAtom*)(*it))->_atomColor[1])/255.0, atoi(((XMBAtom*)(*it))->_atomColor[2])/255.0 );
				gluSphere(quadratic,8,25,25);
			glPopMatrix();
		}

//	for( i=0; i<atomsCount; i++){
//		cout<<"  ATOM "<<atomsArr[i]->getSymbol()<<" "<<atomsArr[i]->getAtomZ()<<" "<<atomsArr[i]->x()<<" "<<atomsArr[i]->y()<<endl;
//	}

	
	for(QCanvasItemList::iterator it=l.begin(); it != l.end(); it++)
	{
		if( (*it)->rtti() == 6 && ((XMBAtom*)(*it))->getMolecule() == molecule )
		{
			QPtrListIterator<XMBBond> bit1( *((XMBAtom*)(*it))->getInList() );
			
			while( (bond = bit1.current()) )
			{
				++bit1;
				bondsArr[ getIndex( bond->getFromAtom() ) ][ getIndex( bond->getToAtom() ) ] = bond;
			}
			QPtrListIterator<XMBBond> bit2( *((XMBAtom*)(*it))->getOutList() );
			while( (bond = bit2.current()) )
			{
				++bit2;
				bondsArr[ getIndex( bond->getFromAtom() ) ][ getIndex( bond->getToAtom() ) ] = bond;
			}
		}
	}

	for(int i=0; i<atomsCount; i++)
		for(int j=0; j<atomsCount; j++)
			if( bondsArr[i][j] != NULL )
			{
//				cout<<"  BOND "<<i<<" "<<j<<" "<<bondsArr[i][j]->bondCount<<" "<<bondsArr[i][j]->bond1Type;
				for(int k=0;k<bondsArr[i][j]->bondCount;k++)
				{
					switch(k)
					{
						case 0:
							if(bondsArr[i][j]->bond1Type==2)
							{
								glPushMatrix();
								glTranslatef( bondsArr[i][j]->getFromAtom()->getAtomZ(),bondsArr[i][j]->getFromAtom()->x()-1000, 1000-bondsArr[i][j]->getFromAtom()->y() );
								double angle=atan((bondsArr[i][j]->getFromAtom()->y()-bondsArr[i][j]->getToAtom()->y())/(float)(bondsArr[i][j]->getToAtom()->x()-bondsArr[i][j]->getFromAtom()->x()))*180.0/M_PI;
								double length=sqrt( (bondsArr[i][j]->getToAtom()->y()-bondsArr[i][j]->getFromAtom()->y())*(bondsArr[i][j]->getToAtom()->y()-bondsArr[i][j]->getFromAtom()->y()) + (bondsArr[i][j]->getToAtom()->x()-bondsArr[i][j]->getFromAtom()->x())*(bondsArr[i][j]->getToAtom()->x()-bondsArr[i][j]->getFromAtom()->x()) );
								if( bondsArr[i][j]->getToAtom()->x() >= bondsArr[i][j]->getFromAtom()->x() )
									glRotatef(angle-90,1,0,0);
								else
									glRotatef(90+angle,1,0,0);
//								glRotatef(angle,1,0,0);
								glRotatef(bondsArr[i][j]->stereoBond->getAngle(),0,1,0);
								glColor3f(0,0,1);
								gluCylinder(quadratic,2,2,fabs(length/cos(bondsArr[i][j]->stereoBond->getAngle()*M_PI/180.0)),22,1);
								glPopMatrix();
								continue;
							}
							else if (bondsArr[i][j]->bond1Type==3)
							{
								glPushMatrix();
								glTranslatef( bondsArr[i][j]->getFromAtom()->getAtomZ(),bondsArr[i][j]->getFromAtom()->x()-1000,1000-bondsArr[i][j]->getFromAtom()->y() );
								double angle=atan((bondsArr[i][j]->getFromAtom()->y()-bondsArr[i][j]->getToAtom()->y())/(float)(bondsArr[i][j]->getToAtom()->x()-bondsArr[i][j]->getFromAtom()->x()))*180.0/M_PI;
								double length=sqrt( (bondsArr[i][j]->getToAtom()->y()-bondsArr[i][j]->getFromAtom()->y())*(bondsArr[i][j]->getToAtom()->y()-bondsArr[i][j]->getFromAtom()->y()) + (bondsArr[i][j]->getToAtom()->x()-bondsArr[i][j]->getFromAtom()->x())* (bondsArr[i][j]->getToAtom()->x()-bondsArr[i][j]->getFromAtom()->x()) );
								if( bondsArr[i][j]->getToAtom()->x() >= bondsArr[i][j]->getFromAtom()->x() )
									glRotatef(angle-90,1,0,0);
								else
									glRotatef(90+angle,1,0,0);
//								glRotatef(angle,1,0,0);
								glRotatef(-bondsArr[i][j]->stereoBond->getAngle(),0,1,0);
								glColor3f(0,0,1);
								gluCylinder(quadratic,2,2,length/cos(bondsArr[i][j]->stereoBond->getAngle()*M_PI/180.0),20,1);
								glPopMatrix();
								continue;
							}
							else
								bondline=bondsArr[i][j]->bond1;
							break;
						case 1:
							bondline=bondsArr[i][j]->bond2;
							break;
						case 2:
							bondline=bondsArr[i][j]->bond3;
							break;
					}
					glPushMatrix();
						glTranslatef(bondline->getBond()->getFromAtom()->getAtomZ(),bondline->getStartPoint().x()-1000 ,1000-bondline->getStartPoint().y() );
						double angle= atan((bondline->getStartPoint().y()-bondline->getEndPoint().y())/(float)(bondline->getEndPoint().x()-bondline->getStartPoint().x()))*180.0/M_PI;
						double length=sqrt( (bondline->getEndPoint().y()-bondline->getStartPoint().y())*(bondline->getEndPoint().y()-bondline->getStartPoint().y()) + (bondline->getEndPoint().x()-bondline->getStartPoint().x())*(bondline->getEndPoint().x()-bondline->getStartPoint().x()) );
						if((bondline->getEndPoint().x() >= bondline->getStartPoint().x()))
							glRotatef(angle-90,1,0,0);
						else
							glRotatef(90+angle,1,0,0);
						double pangle=atan((bondsArr[i][j]->getToAtom()->getAtomZ() - bondsArr[i][j]->getFromAtom()->getAtomZ())/length);
						glRotatef(180/M_PI*pangle,0,1,0);
						glColor3f(0,0,1);
						gluCylinder(quadratic,2,2,length/cos(pangle),20,1);
					glPopMatrix();
				}
			}
	
	for(int i=0; i<atomsCount; i++)
		delete[] bondsArr[i];
	delete[] bondsArr;
	delete[] atomsArr;
}

void XMBI3dView::CreateLists(void)
{
	glNewList(1,GL_COMPILE);
	{
		QCanvasItemList l = canvas->allItems();
		QValueList<XMBMolecule*> l1;
		XMBMolecule *molecule;

		for(QCanvasItemList::iterator it=l.begin(); it != l.end(); it++)
		{
			// get molecule to Display
			if( (*it)->rtti() == 6 && l1.find( ( (XMBAtom*)(*it))->getMolecule() ) == l1.end() )
			{
				molecule = ((XMBAtom*)(*it))->getMolecule();
				l1.append( molecule );
				RenderMolecule(molecule);
			}
		}
	}
	glEndList();
}

void XMBI3dView::init(void)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(100,1280.0/1024.0,0.1,6000.0);
//	glOrtho(-640,640,-512,512,-6000.0,6000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glViewport(0,0,1280,1024);
	
	glShadeModel(GL_SMOOTH);
	glClearColor(0,0,0,1);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

	glBlendFunc(GL_SRC_ALPHA,GL_DST_ALPHA);
	glEnable(GL_TEXTURE_2D);
	
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);

	glLightfv(GL_LIGHT0,GL_AMBIENT,ambience);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuse);
	glLightfv(GL_LIGHT0,GL_SPECULAR,specular);
	glLightfv(GL_LIGHT0,GL_POSITION,position);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	glEnable(GL_COLOR_MATERIAL);

	quadratic=gluNewQuadric();
	gluQuadricNormals(quadratic, GLU_SMOOTH);
	gluQuadricTexture(quadratic, GL_TRUE);

	defaulteye=pos[0]=pos[1]=pos[2]=totalAtomCount=0;
	CreateLists();
	pos[0]/=float(totalAtomCount);
	pos[1]/=float(totalAtomCount);
	pos[2]/=float(totalAtomCount);
	defaulteye+=200;
	eye[0]=defaulteye;	defaultPos[0]=pos[0];
	eye[1]=pos[1];		defaultPos[1]=pos[1];
	eye[2]=pos[2];		defaultPos[2]=pos[2];
}

void XMBI3dView::renderScene(void)
{
	static int sceneTime=0;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	
	gluLookAt(eye[0],eye[1],eye[2],pos[0],pos[1],pos[2],0,0,1);

	glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,128);

	if(rotation[0]||rotation[1])
		glTranslatef(defaultPos[0],defaultPos[1],defaultPos[2]);
	else
		glTranslatef(pos[0],pos[1],pos[2]);
	glRotatef(rotYAngle,0,0,1);
	glRotatef(rotXAngle,0,1,0);
	if(rotation[0]||rotation[1])
		glTranslatef(-defaultPos[0],-defaultPos[1],-defaultPos[2]);
	else
		glTranslatef(-pos[0],-pos[1],-pos[2]);
	glCallList(1);

	if(rotation[0] || rotation[1])
	{
		if(rotation[0])
			rotYAngle+=(SDL_GetTicks()-sceneTime)*0.05;
		if(rotation[1])
			rotXAngle+=(SDL_GetTicks()-sceneTime)*0.03;
		sceneTime=SDL_GetTicks();
	}
/*
	glColor3f(0.0f,0.0f,1.0f);
	setOrthographicProjection(1024,768);
	glPushMatrix();
	glLoadIdentity();
	sprintf(s,"FPS : %4.2f",fps);
	renderBitmapString(30,30,(void *)fps_font,s);
	glPopMatrix();
	resetPerspectiveProjection();
*/
	SDL_GL_SwapBuffers();
	glFlush();
}


bool XMBI3dView::HandleKeyboard(SDL_keysym *KeySym)
{
	static int keytime=0;
        switch(KeySym->sym)
	{
		case SDLK_ESCAPE:
			return true;
		case SDLK_LSHIFT:
		case SDLK_RSHIFT:
			spclkeys=1;
			break;
		case SDLK_f:
			if(SDL_GetTicks()-keytime<KEYLAG)
				break;
			keytime=SDL_GetTicks();
                        SDL_WM_ToggleFullScreen(pSDLSurface);
			break;
		case SDLK_LEFT:
			eye[1]-=1;
			pos[1]-=1;
			break;
		case SDLK_RIGHT:
			eye[1]+=1;
			pos[1]+=1;
			break;
		case SDLK_UP:
			eye[2]+=1;
			pos[2]+=1;
			break;
		case SDLK_DOWN:
			eye[2]-=1;
			pos[2]-=1;
			break;
		case SDLK_w:
			eye[0]-=1;
			break;
		case SDLK_s:
			eye[0]+=1;
			break;
		case SDLK_a:
			pos[1]-=1;
			break;
		case SDLK_d:
			pos[1]+=1;
			break;
		case SDLK_q:
			rotXAngle-=0.3;
			break;
		case SDLK_e:
			rotXAngle+=0.3;
			break;
		case SDLK_z:
			rotYAngle-=0.5;
			break;
		case SDLK_x:
			rotYAngle+=0.5;
			break;
		case SDLK_o:
			pos[0]=defaultPos[0];	pos[1]=defaultPos[1];	pos[2]=defaultPos[2];
			eye[0]=defaulteye;	eye[1]=pos[1];		eye[2]=pos[2];
			rotYAngle=0;
			rotXAngle=0;
			break;
		case SDLK_r:
			if(SDL_GetTicks()-keytime<KEYLAG)
				break;
			keytime=SDL_GetTicks();
			rotation[0]=!rotation[0];
			break;
		case SDLK_t:
			if(SDL_GetTicks()-keytime<KEYLAG)
				break;
			keytime=SDL_GetTicks();
			rotation[1]=!rotation[1];
			break;
		default:
			break;
	}
	return false;
}

void XMBI3dView::view(void)
{
	SDL_Init( SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE );
	SDL_WM_SetCaption( "MOLECULAR I3D VIEWER", NULL );
/*	const SDL_VideoInfo */pSDLVideoInfo = SDL_GetVideoInfo();
	if( !pSDLVideoInfo )
	{
		cout << "SDL_GetVideoInfo() failed. SDL Error: " << SDL_GetError() << endl;
		SDL_Quit();
		return;
	}
//	atexit(SDL_Quit);
	
	if( pSDLVideoInfo->hw_available )
		nFlags |= SDL_HWSURFACE;
	else
		nFlags |= SDL_SWSURFACE;
	if( pSDLVideoInfo->blit_hw )
		nFlags |= SDL_HWACCEL;
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
	
/*	SDL_Surface */pSDLSurface = SDL_SetVideoMode(1285, 1029, 32, nFlags );
	if( !pSDLSurface )
	{
		cout << "Call to SDL_SetVideoMode() failed! - SDL_Error: " << SDL_GetError() << endl;
		SDL_Quit();
		return;
	}
	
	init();
	
	bool Done = false;
	SDL_Event Event;
	while( !Done )
	{
		SDL_PollEvent(&Event);
		switch(Event.type)
		{
			case SDL_QUIT:
				Done = true;
				break;
			case SDL_KEYDOWN:
				Done=HandleKeyboard(&Event.key.keysym);
				break;
/*			case SDL_KEYUP:
				if(Event.key.keysym.sym==SDLK_LSHIFT || Event.key.keysym.sym==SDLK_RSHIFT)
					spclkeys=0;
				break;
			case SDL_MOUSEBUTTONDOWN:
				int x=0,y=0;
				switch(SDL_GetRelativeMouseState(&x,&y))
				{
					case SDL_BUTTON_LEFT:
						eye[0]=(pos[0]+rho*cos(2*asin(sqrt(x*x+y*y)/(2*rho))));
						eye[1]=pos[1]+(sqrt(x*x - (rho-eye[0])*(rho-eye[0])) * (x>=0?-1:1));
					       	eye[2]=pos[2]-y;
						break;
					case SDL_BUTTON_RIGHT:
						eye[1]-=x;	pos[1]-=x;
						eye[2]-=y;	pos[2]-=y;
						break;
					case SDL_BUTTON_MIDDLE:
						axis[0]=1;	axis[1]=0;	axis[2]=0;
//						angle
						break;
					case SDL_BUTTON_WHEELUP:
						eye[0]-=1;	pos[0]-=1;
						break;
					case SDL_BUTTON_WHEELDOWN:
						eye[0]+=1;	pos[0]+=1;
						break;
					default:break;
				}
				break;
*/
			default:break;
		}
		renderScene();
	}
	SDL_Quit();
}
