/****************************************************************************
  XMBStereoBond.h  -  description
  -------------------
begin                : Fri Jul 21 2006
copyright            : (C) 2006 by ImazInatIon
email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *************************************************************************}*/

#ifndef XMBSTEREOBOND_H
#define XMBSTEREOBOND_H

#include <qcanvas.h>
#include <qpointarray.h>
#include "xmoleculebuilderdoc.h"
#include "XMBBond.h"

class XMoleculeBuilderDoc;
class XMBBond;

/**
 *@author Revanth
 */

class XMBStereoBond : public QCanvasPolygon  {
	public:
		// constructor
		XMBStereoBond( QPoint, QPoint,  QPoint, XMoleculeBuilderDoc *pDoc, XMBBond *b, XMBBondType bondType, float angle=60);

		// destructor
		~XMBStereoBond();

		// set endpoints
		void setFromPoint( double x, double y );
		void setToPoint( double x1, double y1, double x2, double y2 ) ;

		// get endpoints
		QPointArray *getPointsArray();

		// get parent bond
		XMBBond *getBond(void);

		// delete parent bond
		void deleteBond(void);

		// get bond projection angle
		float getAngle(void);

		// set bond projection angle
		void setAngle(float angle);

		// move the bond
		void moveBy(double dx, double dy);
		void myMoveBy(double dx, double dy);

		// set colour
		void setColor( int r, int g, int b);

		// hover
		void startHover();
		void stopHover();
	private:
		// parent
		XMBBond *bond;

		XMBBondType bondType;
		QPointArray *pa;

		// colour of the bond
		int color[3];

		// bond projection angle
		float pangle;

		// show symbol on canvas
		QCanvasText *canvasSymbol;
};

#endif


