/***************************************************************************
  xmoleculebuilderdoc.cpp  -  description
  -------------------
 begin                : Fri Jul 21 18:57:53 IST 2006
 copyright            : (C) |2006| by Revanth
 email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "xmoleculebuilderdoc.h"
#include "XMBFileIO.h"
#include <iostream>
using namespace std;

XMoleculeBuilderDoc::XMoleculeBuilderDoc()
{
	modified = false;
	docName=tr("noname.xmb");
}

XMoleculeBuilderDoc::~XMoleculeBuilderDoc()
{
}

void XMoleculeBuilderDoc::newDoc()
{
	canvas = new QCanvas(2000,2000);
	canvas->setDoubleBuffering(true);
	canvas->setBackgroundColor(QColor("white"));
	canvas->setAdvancePeriod(25);
	modified = true;
	emit documentChanged();
}

bool XMoleculeBuilderDoc::save()
{
	if ( modified )
	{
		QFile f(docName);
		if( !f.open(IO_WriteOnly ))
			return false;

		QTextStream s( &f );

		XMBFileIO t;
		t.writeWorkspace( s, canvas );
		f.close();
	}
	return true;
}

bool XMoleculeBuilderDoc::saveAs(const QString &filename)
{
	QFile f(filename);
	if( !f.open(IO_WriteOnly ))
		return false;

	QTextStream s( &f );

	XMBFileIO t;
	t.writeWorkspace( s, canvas );
	f.close();
	
	return true;
}

bool XMoleculeBuilderDoc::load(const QString &filename,bool locked)
{
	QFile f(filename);
	if( !f.open(IO_ReadOnly ))
		return false;

	QTextStream s( &f );

	XMBFileIO t;
	t.readWorkspace( s, this, locked);
	
	f.close();
	emit documentChanged();
	return true;
}

bool XMoleculeBuilderDoc::isModified() const
{
	return modified;
}


