/***************************************************************************
  xmoleculebuilderview.h  -  description
  -------------------
 begin                : Fri Jul 21 18:57:53 IST 2006
 copyright            : (C) |2006| by Revanth
 email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XMOLECULEBUILDERVIEW_H
#define XMOLECULEBUILDERVIEW_H

// include files for QT
#include <qwidget.h>
#include <qcanvas.h>
// application specific includes
#include "xmoleculebuilderdoc.h"
#include "XMBAtom.h"
#include "XMBBond.h"
#include "XMBBondLine.h"
#include "XMBStereoBond.h"
#include "xmoleculebuilder.h"

//class XMoleculeBuilderApp *xmoleculebuilder;//=new XMoleculeBuilderApp();

class XMBAtom;
class XMBBond;
class XMoleculeBuilderDoc;
//class XMoleculeBuilderApp;
enum XMBViewState{
	XMBVS_view,
	XMBVS_rotate,
	XMBVS_drawSimpleBond,
	XMBVS_drawDashedBond,
	XMBVS_drawStereoUp,
	XMBVS_drawStereoDown,
	XMBVS_deleteItem,
	XMBVS_zigzag
};

/**
 * This class provides an incomplete base for your application view. 
 */

class XMoleculeBuilderView : public QCanvasView //, private QMainWindow
{
	Q_OBJECT
	public:
		XMoleculeBuilderView(/*XMoleculeBuilderApp*/QWidget* parent=0, XMoleculeBuilderDoc* doc=0);
		~XMoleculeBuilderView();

	protected slots:
		
		void slotDocumentChanged();
	
	public:

		/** functions to do on mouse press on the canvas view */
		void contentsMousePressEvent( QMouseEvent *e);
	
		/** functions to do on mouse released on the canvas view */
		void contentsMouseReleaseEvent( QMouseEvent *e);
	
		void addBond( XMBBond *, XMBViewState );
		void drawZigZag(QMouseEvent *e);
		void drawBond(QMouseEvent *e);
		/** on mouse move on the canvas */
		void contentsMouseMoveEvent(QMouseEvent* e);
		void MouseMoveEvent(QMouseEvent* e);
	
		void startHover( QPoint p);
		void stopHover(void);
	
		//protected:
		XMoleculeBuilderDoc *doc;
		
		//priva	te:
	
		XMBViewState canvasState;
		float fixedAngleValue, fixedLengthValue, newx, newy;
		int	fixedAngleFlag, fixedLengthFlag;
		XMBAtom *lastAtom;
		int isLastAtom;
		QCanvasItem* moving;
		QCanvasItem* hover;
		QPoint moving_start;

	signals:
		void zigzagAtomValue(int);
		void displayBondDetail(char*);
	
	private:
		float getZplane ( void );
		bool flag;
//		QWidget/*XMoleculeBuilderApp*/ *app;
};

#endif
